import { type Substitution } from "../substitution/index.ts";
export type Exp = Var | Fn | FnRec | Ap | Let;
export type Var = {
    kind: "Var";
    name: string;
};
export type Fn = {
    kind: "Fn";
    name: string;
    ret: Exp;
};
export type FnRec = {
    kind: "FnRec";
    recName: string;
    name: string;
    ret: Exp;
};
export type Ap = {
    kind: "Ap";
    target: Exp;
    arg: Exp;
};
export type Let = {
    kind: "Let";
    substitution: Substitution;
    body: Exp;
};
export declare function Var(name: string): Var;
export declare function Fn(name: string, ret: Exp): Fn;
export declare function FnRec(recName: string, name: string, ret: Exp): FnRec;
export declare function Ap(target: Exp, arg: Exp): Ap;
export declare function Let(substitution: Substitution, body: Exp): Let;
//# sourceMappingURL=Exp.d.ts.map