import { modDefine, modFind, modResolve } from "../mod/index.js";
import { runMod } from "./runMod.js";
export function importOne(mod, path, entry) {
    const url = modResolve(mod, path);
    if (url.href === mod.url.href) {
        throw new Error(`I can not circular import: ${path}`);
    }
    const found = mod.loadedMods.get(url.href);
    if (found === undefined) {
        throw new Error(`Mod is not loaded: ${path}`);
    }
    runMod(found.mod);
    const { name, rename } = entry;
    const def = modFind(found.mod, name);
    if (def === undefined) {
        throw new Error(`I can not import undefined name: ${name}, from path: ${path}`);
    }
    modDefine(mod, rename || name, def);
}
//# sourceMappingURL=importOne.js.map